function [R] = Rubella(q, v, dataset, matrix, N, S, varargin)

%   Copyright (c) 2023-2024 Simone De Reggi.
%
%   If you use this software for a scientific publication,
%   please cite the following papers:
%
%   [1] S. De Reggi, F. Scarabel, R. Vermiglio, ''Approximating reproduction numbers:
%         a general numerical method for age-structured models.'' Mathematical Biosciences
%         and Engineering, 2024, 21(4): 5360-5393. doi: 10.3934/mbe.2024236
%   [2] S. De Reggi, F. Scarabel, R. Vermiglio, ''On the convergence of the pseudospectral
%         approximation of reproduction numbers for age-structured models.'' (submitted).
%
%   Refers to Example 4.4 in [1]
%
%   q in [0, 1] is the probability of vertical transmission
%   v in [0, 3] is the percapita vaccination rate
%
%   dataset == 1 gives data from South East of England (1980)
%   dataset == 2 gives data from Leeds (1978)
%   default is dataset 1
%
%   matrix == 1 gives the WAIFW matrix of type 1
%   matrix == 2 gives the WAIFW matrix of type 2
%   matrix == 3 gives the WAIFW matrix of type 3
%   default is matrix 1
%
%   Put S==0 for the discretization at the Chebyshev zeros
%   or S==1 for for the discretization at Chebyshev extrema
%
%   Rubella(q, v, dataset, matrix, N, S, varargin) default computes R_0
%   if varargin == 2, it computes T_H
%   if varargin == 3, it computes T_V

if S ~= 0 && S  ~= 1
    S = 0;
    fprintf('Wrong value of S. Automatically setted to S = 0\n');
end

if dataset ~=1 && dataset ~=2
    dataset =1;
end

if matrix ~=1 && matrix ~=2 && matrix ~=3
    matrix = 1;
end

if isempty(varargin) || (varargin{1} ~= 2 && varargin{1} ~= 3)
    index = 1;
elseif varargin{1}==2
    index = 2;
elseif varargin{1}==3
    index = 3;
end

a=[0, 75];   
z = [5,  10,  15, 20, 30];
d=2;

% specific parameter definition

eta = 4;
sigma = 34.76;
gamma = 31.74;

[Kij]=gamma*WAIFW(dataset, matrix);

delta={@(x) [-sigma, 0; sigma, -gamma],...
            @(x) [-sigma, 0; sigma, -gamma],...
            @(x) [-sigma, 0; sigma, -gamma],...
            @(x) [-sigma, 0; sigma, -gamma],...
            @(x) [-sigma, 0; sigma, -gamma],...
            @(x) [-sigma, 0; sigma, -gamma]};

switch index 
    case 1
        b1={@(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75]}; 
        b2={@(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0]};  
  beta1={@(x, y) Sus(x, eta, v)*[0, Kij(1, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(1, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(1, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(1, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(1, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(1, 6); 0, 0];...
               @(x, y) Sus(x, eta, v)*[0, Kij(2, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(2, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(2, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(2, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(2, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(2, 6); 0, 0];
               @(x, y) Sus(x, eta, v)*[0, Kij(3, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(3, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(3, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(3, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(3, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(3, 6); 0, 0];
               @(x, y) Sus(x, eta, v)*[0, Kij(4, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(4, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(4, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(4, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(4, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(4, 6); 0, 0];
               @(x, y) Sus(x, eta, v)*[0, Kij(5, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(5, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(5, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(5, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(5, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(5, 6); 0, 0];
               @(x, y) Sus(x, eta, v)*[0, Kij(6, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(6, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(6, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(6, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(6, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(6, 6); 0, 0]};  
  beta2={@(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0]};
    case 2
        b1={@(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0]};  
        b2={@(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75]};             
  beta1={@(x, y) Sus(x, eta, v)*[0, Kij(1, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(1, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(1, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(1, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(1, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(1, 6); 0, 0];...
               @(x, y) Sus(x, eta, v)*[0, Kij(2, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(2, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(2, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(2, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(2, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(2, 6); 0, 0];
               @(x, y) Sus(x, eta, v)*[0, Kij(3, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(3, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(3, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(3, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(3, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(3, 6); 0, 0];
               @(x, y) Sus(x, eta, v)*[0, Kij(4, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(4, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(4, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(4, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(4, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(4, 6); 0, 0];
               @(x, y) Sus(x, eta, v)*[0, Kij(5, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(5, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(5, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(5, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(5, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(5, 6); 0, 0];
               @(x, y) Sus(x, eta, v)*[0, Kij(6, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(6, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(6, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(6, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(6, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(6, 6); 0, 0]};    beta2={@(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0]};
    case 3
        b1={@(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75],...
                @(x) [0, 0; 0, q/75]}; 
        b2={@(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0],...
                @(x) [0, 0; 0, 0]};  
  beta1={@(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0];...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0],...
                @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0], @(x, y) [0, 0; 0, 0]};
  beta2={@(x, y) Sus(x, eta, v)*[0, Kij(1, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(1, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(1, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(1, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(1, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(1, 6); 0, 0];...
               @(x, y) Sus(x, eta, v)*[0, Kij(2, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(2, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(2, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(2, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(2, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(2, 6); 0, 0];
               @(x, y) Sus(x, eta, v)*[0, Kij(3, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(3, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(3, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(3, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(3, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(3, 6); 0, 0];
               @(x, y) Sus(x, eta, v)*[0, Kij(4, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(4, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(4, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(4, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(4, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(4, 6); 0, 0];
               @(x, y) Sus(x, eta, v)*[0, Kij(5, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(5, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(5, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(5, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(5, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(5, 6); 0, 0];
               @(x, y) Sus(x, eta, v)*[0, Kij(6, 1); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(6, 2); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(6, 3); 0, 0],...
               @(x, y) Sus(x, eta, v)*[0, Kij(6, 4); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(6, 5); 0, 0], @(x, y) Sus(x, eta, v)*[0, Kij(6, 6); 0, 0]};  
end

b={b1, b2};
beta={beta1, beta2};

if S == 1
    [BN, MN] = RepNumASM(a, z, d, b, delta, beta, N, 1);
else
    [BN, MN] = RepNumASM(a, z, d, b, delta, beta, N, 0);
end

BN=sparse(BN);
MN=sparse(MN);
e = sort(eigs(BN/MN), 'ComparisonMethod','real');
R=e(end);

end

%% Density of susceptibles at disease free equilibrium

function [s] = Sus(a, eta, v)

%   Computes the density of susceptibles individuals in 
%   the linearization around the disease free equilibrium for Example 3
%   in [1].
%
%   [1] S. De Reggi, F. Scarabel, R. Vermiglio, ''Approximating reproduction numbers:
%         a general numerical method for age-structured models.'' Mathematical Biosciences
%         and Engineering, 2024, 21(4): 5360-5393. doi: 10.3934/mbe.2024236

if v==0
    s=1;
else
    s0 = ((eta/(v-eta))*(1/75)*((1-exp(-75*eta))/eta+(exp(-75*v)-1)/v))/...
         (1-((1-exp(-75*v))/(75*v)-...
         ((eta/(v-eta))*(1/75)*((1-exp(-75*eta))/eta+(exp(-75*v)-1)/v))));
    
    s = s0*(exp(-v*a)-eta/(v-eta)*(exp(-eta*a)-exp(-v*a)))+...
        eta/(v-eta)*(exp(-eta*a)-exp(-v*a));    
end
end

%% WAIFW matrix

function [K]=WAIFW(dataset, matrix)

%   Computes the WAIFW matrix relevant to model (4.4)
%   in [1] using data from [2] and the method of [3, Appendix A].
%
%   [1] S. De Reggi, F. Scarabel, R. Vermiglio, ''Approximating reproduction numbers:
%         a general numerical method for age-structured models.'' Mathematical Biosciences
%         and Engineering, 2024, 21(4): 5360-5393. doi: 10.3934/mbe.2024236
%   [2] R. Anderson and B. Grenfell, ''Quantitative investigations of different 
%        vaccination policies for the control of congenital rubella syndrome (CRS)
%        in the United Kingdom'', Epidemiol. Infect., 96 (1986), 305-333
%   [3] R. Anderson and R.May, ''Age-related changes  in the rate of disease
%        transmission: implications for the design of vaccination programmes'',
%        Epidemiol. Infect., 94 (1985), 365-436
%     

a=[0, 5, 10, 15, 20, 30, 75];

if dataset == 1
    lambda=[0.081, 0.115, 0.115, 0.083, 0.091, 0.067]; %south of england
else
    lambda=[0.089, 0.134, 0.151, 0.148, 0.126, 0.126]; %leeds
end

n=size(a, 2); %esempio a=[0, 5, 10, 15, 20, 30, 75]
n=n-1;

psi=ones(1, n+1);
psi(1)=0;

for i=2:n+1
    psi(i)=0;
    j=2;
    while j<=i
        psi(i)=psi(i)+lambda(j-1)*(a(j)-a(j-1));
        j=j+1;
    end
end

PSI=ones(1, n);

for i=1:n
   PSI(i)=exp(-psi(i))-exp(-psi(i+1)); 
end

S=sum(PSI);

switch matrix
    case 1
        A=[PSI(1)+PSI(2), 0, PSI(3), PSI(4), PSI(5), PSI(6);...
           PSI(1), PSI(2), PSI(3), PSI(4), PSI(5), PSI(6);...
           0, 0, PSI(1)+PSI(2)+PSI(3), PSI(4), PSI(5), PSI(6);...
           0, 0, 0, S-PSI(5)-PSI(6), PSI(5), PSI(6);...
           0, 0, 0, 0, S-PSI(6), PSI(6);...
           0, 0, 0, 0, 0, S];        
    case 2
        A=[PSI(1), 0, 0, 0, 0, S-PSI(1);...
           0, PSI(2), 0, 0, 0, S-PSI(2);...
           0, 0, PSI(3), 0, 0, S-PSI(3);...
           0, 0, 0, PSI(4), 0, S-PSI(4);...
           0, 0, 0, 0, PSI(5), S-PSI(5);...
           0, 0, 0, 0, 0, S];
    case 3
        A=[PSI(1), 0, 0, 0, PSI(5), S-PSI(1)-PSI(5);...
           0, PSI(2), 0, 0, PSI(5), S-PSI(2)-PSI(5);...
           0, 0, PSI(3), 0, 0, S-PSI(3);...
           0, 0, 0, PSI(4), 0, S-PSI(4);...
           0, 0, 0, 0, PSI(1)+PSI(2)+PSI(5), S-PSI(1)-PSI(2)-PSI(5);...
           0, 0, 0, 0, 0, S];             
end

k=A^(-1)*lambda';

switch matrix
    case 1
        K=[k(1), k(1), k(3), k(4), k(5), k(6);...
           k(1), k(2), k(3), k(4), k(5), k(6);...
           k(3), k(3), k(3), k(4), k(5), k(6);...
           k(4), k(4), k(4), k(4), k(5), k(6);...
           k(5), k(5), k(5), k(5), k(5), k(6);...
           k(6), k(6), k(6), k(6), k(6), k(6)];
    case 2
        K=ones(6)*k(6);
        for i=1:5
            K(i, i)=k(i);
        end
    case 3
        K=ones(6)*k(6);
        for i=1:5
            K(i, i)=k(i);
        end
        K(5, 1)=k(5);
        K(5, 2)=k(5);
        K(1, 5)=k(5);
        K(2, 5)=k(5);
end

end